<?php

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* ADVANCED */

define('SET_SESSION_NAME','');			// Session name
define('DO_NOT_START_SESSION','1');		// Set to 1 if you have already started the session
define('DO_NOT_DESTROY_SESSION','0');	// Set to 1 if you do not want to destroy session on logout
define('SWITCH_ENABLED','1');
define('INCLUDE_JQUERY','1');
define('FORCE_MAGIC_QUOTES','0');

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* DATABASE */


if (!file_exists(dirname(dirname(__FILE__)).DIRECTORY_SEPARATOR."data".DIRECTORY_SEPARATOR."config".DIRECTORY_SEPARATOR."config.php")) {
	echo "Please check if cometchat is installed in the correct directory.<br /> The 'cometchat' folder should be placed at <JAMROOM_HOME_DIRECTORY>/cometchat";
	exit;
}
include_once(dirname(dirname(__FILE__)).DIRECTORY_SEPARATOR."data".DIRECTORY_SEPARATOR."config".DIRECTORY_SEPARATOR."config.php");

// DO NOT EDIT DATABASE VALUES BELOW


define('DB_SERVER',				$_conf['jrCore_db_host']		);
define('DB_PORT',				$_conf['jrCore_db_port']		);
define('DB_USERNAME',			$_conf['jrCore_db_user']		);
define('DB_PASSWORD',			$_conf['jrCore_db_pass']		);
define('DB_NAME',				$_conf['jrCore_db_name']		);
if(defined('USE_CCAUTH') && USE_CCAUTH == '0'){
define('TABLE_PREFIX',				''								);
if (strpos($_SERVER['PHP_SELF'],'/install.php') !== false) {
	$conn = mysqli_connect(DB_SERVER.':'.DB_PORT,DB_USERNAME,DB_PASSWORD);
	$dbh = mysqli_select_db($conn, DB_NAME);
	$sql =("CREATE TABLE if not exists `cometchat_users` (`userid` int(10) unsigned NOT NULL auto_increment, `username` varchar(255) NOT NULL, `user_group` varchar(255) NOT NULL, PRIMARY KEY  (`userid`)) ENGINE=InnoDB DEFAULT CHARSET = utf8 COLLATE utf8_unicode_ci;");
	mysqli_query($conn,$sql);
	$sql = ("insert ignore into cometchat_users(userid,username,user_group)(SELECT item_id_tbl._item_id userid, username_tbl.value username, user_group_tbl.value user_group from jr_jruser_item_key item_id_tbl join jr_jruser_item_key username_tbl on item_id_tbl._item_id = username_tbl._item_id and username_tbl.key = 'user_name' join jr_jruser_item_key user_active_tbl on item_id_tbl._item_id = user_active_tbl._item_id and user_active_tbl.key = 'user_active' and user_active_tbl.value ='1' join jr_jruser_item_key user_group_tbl on item_id_tbl._item_id = user_group_tbl._item_id and user_group_tbl.key = 'user_group'  group by item_id_tbl._item_id);");
	mysqli_query($conn,$sql);
}
define('DB_USERTABLE',                          "cometchat_users" 					);
define('DB_USERTABLE_USERID',                   "userid"							);
define('DB_USERTABLE_NAME',                     "username"							);
define('DB_AVATARTABLE',                        ""								);
define('DB_AVATARFIELD',                        " ".TABLE_PREFIX.DB_USERTABLE.".userid"						);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* FUNCTIONS */

	function getUserID() {
		global $_conf;
		$userid = 0;
		if (!empty($_SESSION['basedata']) && $_SESSION['basedata'] != 'null') {
			$_REQUEST['basedata'] = $_SESSION['basedata'];
		}
		if (!empty($_REQUEST['basedata'])) {
			if (function_exists('mcrypt_encrypt') && defined('ENCRYPT_USERID') && ENCRYPT_USERID == '1') {
				$key = "";
				if( defined('KEY_A') && defined('KEY_B') && defined('KEY_C') ){
					$key = KEY_A.KEY_B.KEY_C;
				}
				$uid = rtrim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, md5($key), base64_decode(rawurldecode($_REQUEST['basedata'])), MCRYPT_MODE_CBC, md5(md5($key))), "\0");
				if (intval($uid) > 0) {
					$userid = $uid;
				}
			} else {
				$userid = $_REQUEST['basedata'];
			}
		}
		if (!empty($_COOKIE['auto'.substr(md5($_conf['jrCore_base_url']), 0, 12)])) {
			$user = explode('-',$_COOKIE['auto'.substr(md5($_conf['jrCore_base_url']), 0, 12)]);
			
			$userid = $user[0];
		}

		$userid = intval($userid);
		$sql = ("insert into cometchat_users(userid,username,user_group,lastactivity)(SELECT item_id_tbl._item_id userid, username_tbl.value username, user_group_tbl.value user_group, '0' lastactivity from jr_jruser_item_key item_id_tbl join jr_jruser_item_key username_tbl on item_id_tbl._item_id = username_tbl._item_id and username_tbl.key = 'user_name' join jr_jruser_item_key user_active_tbl on item_id_tbl._item_id = user_active_tbl._item_id and user_active_tbl.key = 'user_active' and user_active_tbl.value ='1' join jr_jruser_item_key user_group_tbl on item_id_tbl._item_id = user_group_tbl._item_id and user_group_tbl.key = 'user_group' and item_id_tbl._item_id = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'  group by item_id_tbl._item_id) on duplicate key update username = (SELECT jr_jruser_item_key.value from jr_jruser_item_key where jr_jruser_item_key.key = 'user_name' and jr_jruser_item_key._item_id = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'), user_group = (SELECT jr_jruser_item_key.value from jr_jruser_item_key where jr_jruser_item_key.key = 'user_group' and jr_jruser_item_key._item_id = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."');");
		$query = mysqli_query($GLOBALS['dbh'],$sql);

		return $userid;
	}

	function chatLogin($userName,$userPass) {
		require_once(dirname(dirname(__FILE__)).DIRECTORY_SEPARATOR."modules".DIRECTORY_SEPARATOR."jrUser".DIRECTORY_SEPARATOR."contrib".DIRECTORY_SEPARATOR."phpass".DIRECTORY_SEPARATOR."PasswordHash.php");
		$userid = 0;
		$sql = ("SELECT _item_id FROM `jr_jruser_item_key` WHERE `value` ='".$userName."'");
		$result = mysqli_query($GLOBALS['dbh'],$sql);
		$row = mysqli_fetch_assoc($result);
		$sql = ("SELECT value FROM `jr_jruser_item_key` WHERE _item_id ='".$row['_item_id']."' and `key`= 'user_password'");
		$result = mysqli_query($GLOBALS['dbh'],$sql) or die(mysqli_error());
		$row1 = mysqli_fetch_assoc($result);
		$password = $row1['value'];
		$passobject =  new PasswordHash;
		if ($passobject->CheckPassword($userPass,$password)) {
			$userid = $row['_item_id'];
			$sql = ("select * from cometchat_users where userid = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'");
			$query = mysqli_query($GLOBALS['dbh'],$sql);
			if (mysqli_num_rows($query) == 0) {
				$sql = ("insert ignore into cometchat_users(userid,username,user_group,lastactivity)(SELECT item_id_tbl._item_id userid, username_tbl.value username, user_group_tbl.value user_group, '0' lastactivity from jr_jruser_item_key item_id_tbl join jr_jruser_item_key username_tbl on item_id_tbl._item_id = username_tbl._item_id and username_tbl.key = 'user_name' join jr_jruser_item_key user_active_tbl on item_id_tbl._item_id = user_active_tbl._item_id and user_active_tbl.key = 'user_active' and user_active_tbl.value ='1' join jr_jruser_item_key user_group_tbl on item_id_tbl._item_id = user_group_tbl._item_id and user_group_tbl.key = 'user_group' where item_id_tbl._item_id = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."' group by item_id_tbl._item_id);");
				mysqli_query($GLOBALS['dbh'],$sql);
			}
	                if (isset($_REQUEST['callbackfn']) && $_REQUEST['callbackfn'] == 'mobileapp') {
	                    $sql = ("insert into cometchat_status (userid,isdevice) values ('".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."','1') on duplicate key update isdevice = '1'");
	                    mysqli_query($GLOBALS['dbh'], $sql);
	                }
		}
		if ($userid && function_exists('mcrypt_encrypt') && defined('ENCRYPT_USERID') && ENCRYPT_USERID == '1') {
			$key = "";
				if( defined('KEY_A') && defined('KEY_B') && defined('KEY_C') ){
					$key = KEY_A.KEY_B.KEY_C;
				}
			$userid = rawurlencode(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, md5($key), $userid, MCRYPT_MODE_CBC, md5(md5($key)))));
		}
		return $userid;
	}

	function getFriendsList($userid,$time) {
		$sql = ("select DISTINCT ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." userid, ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." username, cometchat_status.lastactivity lastactivity, ".DB_AVATARFIELD." avatar, ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." link, cometchat_status.message, cometchat_status.status, cometchat_status.isdevice from ".TABLE_PREFIX.DB_USERTABLE." left join cometchat_status on ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." = cometchat_status.userid ".DB_AVATARTABLE." Join jr_jrfollower_item_key follower_tbl JOIN jr_jrfollower_item_key followee ON followee.value = ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." AND follower_tbl._item_id = followee._item_id AND follower_tbl.key = 'follow_active' AND follower_tbl.value = 1 AND followee.key='_user_id' JOIN jr_jrfollower_item_key follower ON follower._item_id = follower_tbl._item_id AND follower.key = 'follow_profile_id' where follower.value = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'");

		if ((defined('MEMCACHE') && MEMCACHE <> 0) || DISPLAY_ALL_USERS == 1) {
			$sql = ("select DISTINCT ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." userid, ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." username, cometchat_status.lastactivity lastactivity, ".DB_AVATARFIELD." avatar, ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." link, cometchat_status.message, cometchat_status.status, cometchat_status.isdevice from ".TABLE_PREFIX.DB_USERTABLE." left join cometchat_status on ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." = cometchat_status.userid ".DB_AVATARTABLE."  order by username asc");
		}

		return $sql;
	}

	function getFriendsIds($userid) {
		$sql = ("SELECT follower1.value friendid FROM jr_jrfollower_item_key follower2 JOIN jr_jrfollower_item_key follower1 ON follower2._item_id = follower1._item_id AND follower2.key =  'follow_active' AND follower2.value ='1' AND follower1.key =  '_user_id' JOIN jr_jrfollower_item_key follower3 ON follower3._item_id = follower2._item_id AND follower3.key = 'follow_profile_id' WHERE follower3.value ='".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'");

		return $sql;
	}

	function getUserDetails($userid) {
		$sql = ("select DISTINCT ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." userid, ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." username, cometchat_status.lastactivity lastactivity,  ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_NAME." link, ".DB_AVATARFIELD." avatar, cometchat_status.message, cometchat_status.status, cometchat_status.isdevice from ".TABLE_PREFIX.DB_USERTABLE." left join cometchat_status on ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." = cometchat_status.userid ".DB_AVATARTABLE." where ".TABLE_PREFIX.DB_USERTABLE.".".DB_USERTABLE_USERID." = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'");

		return $sql;
	}

	function updateLastActivity($userid) {
		$sql = ("insert into cometchat_status (userid,lastactivity) values ('".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."','".getTimeStamp()."') on duplicate key update lastactivity = '".getTimeStamp()."'");

		return $sql;
	}

	function getUserStatus($userid) {
		$sql = ("select cometchat_status.message, cometchat_status.status from cometchat_status where userid = '".mysqli_real_escape_string($GLOBALS['dbh'],$userid)."'");

		return $sql;
	}

	function fetchLink($link) {
		return BASE_URL.'../'.$link;
	}

	function getAvatar($image) {
	        if(!empty($image)) {
	                return BASE_URL.'../profile/image/profile_image/'.$image.'/small/crop=auto';
	        } else {
	                return BASE_URL.'images/noavatar.png';
	        }
	}

	function getTimeStamp() {
		return time();
	}

	function processTime($time) {
		return $time;
	}

	if (!function_exists('getLink')) {
	  	function getLink($userid) {
			return fetchLink($userid);
		}
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/* HOOKS */

	function hooks_updateLastActivity($userid) {

	}

	function hooks_statusupdate($userid,$statusmessage) {

	}

	function hooks_forcefriends() {

	}

	function hooks_activityupdate($userid,$status) {

	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* LICENSE */

include_once(dirname(__FILE__).DIRECTORY_SEPARATOR.'license.php');
$x="\x62a\x73\x656\x34\x5fd\x65c\157\144\x65";
eval($x('JHI9ZXhwbG9kZSgnLScsJGxpY2Vuc2VrZXkpOyRwXz0wO2lmKCFlbXB0eSgkclsyXSkpJHBfPWludHZhbChwcmVnX3JlcGxhY2UoIi9bXjAtOV0vIiwnJywkclsyXSkpOw'));

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
